/*  Copyright (C) 2015 Michele Santullo
 *
 *  This file is part of DuckScraper.
 *
 *  DuckScraper is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DuckScraper is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with DuckScraper.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef idCDCACC393BE24CBD94A3B5E2985984A3
#define idCDCACC393BE24CBD94A3B5E2985984A3

#include "scraplang/html_pool_base.hpp"
#include "iconv_wrapper.hpp"

namespace duck {
	class HtmlPool : public ::duck::sl::HtmlPoolBase {
		typedef ::duck::sl::HtmlPoolBase::ResourceType ResourceType;
		typedef ::duck::sl::HtmlPoolBase::ResourceNameType ResourceNameType;
		typedef ::duck::sl::HtmlPoolBase::ResourceObjectParameterType ResourceObjectParameterType;
		typedef ::duck::sl::HtmlPoolBase::ResourceNameParamType ResourceNameParamType;

		virtual ResourceType* OnResourceLoad (ResourceObjectParameterType parRes);
		virtual void OnResourceDestroy (ResourceNameParamType parName, ResourceType* parRes) noexcept;
		virtual ResourceNameType GetResourceNameFromResourceObject (ResourceObjectParameterType parRes);

		std::string m_agent;
		std::string m_src_charset;
		IconvWrapper m_iconv;

	public:
		HtmlPool(std::string&& agent_name, std::string&& src_charset);
		~HtmlPool() noexcept;
	};
} //namespace duck

#endif
