/*  Copyright (C) 2015 Michele Santullo
 *
 *  This file is part of DuckScraper.
 *
 *  DuckScraper is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DuckScraper is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with DuckScraper.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "read_all.hpp"
#include <fstream>
#include <iterator>

namespace duck {
	std::string read_all (std::istream& parStream) {
		parStream >> std::noskipws;
		std::istream_iterator<char> it(parStream);
		std::istream_iterator<char> end;
		return std::string(it, end);
	}

	std::string read_all (std::istream&& parStream) {
		return read_all(parStream);
	}

	std::string read_all (const std::string& parPath) {
		return read_all(std::ifstream(parPath));
	}
} //namespace duck
