/*  Copyright (C) 2015 Michele Santullo
 *
 *  This file is part of DuckScraper.
 *
 *  DuckScraper is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DuckScraper is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with DuckScraper.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef idDD58822D7D8B4AA7A0DD16B1CDEF413E
#define idDD58822D7D8B4AA7A0DD16B1CDEF413E

#include "implem/ResourcePool.hpp"
#include "kakoune/safe_ptr.hh"
#include <string_view>

namespace duck { namespace sl {
	namespace implem {
		typedef duckutil::ResourcePool<std::string, std::string_view> HtmlPoolBase;
	} //namespace implem

	class HtmlPoolBase : public implem::HtmlPoolBase, public Kakoune::SafeCountable {
	public:
		using implem::HtmlPoolBase::HtmlPoolBase;
		using implem::HtmlPoolBase::operator=;
	};

	typedef Kakoune::SafePtr<HtmlPoolBase> HtmlPoolBaseSP;
}} //namespace duck::sl

#endif
