/*  Copyright (C) 2015 Michele Santullo
 *
 *  This file is part of DuckScraper.
 *
 *  DuckScraper is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DuckScraper is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with DuckScraper.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef idDB3415BA82504C00A2DAF0274BA9AC92
#define idDB3415BA82504C00A2DAF0274BA9AC92

#include "scrap_node.hpp"
#include <iostream>

namespace duck { namespace sl {
	std::ostream& operator<< (std::ostream& stream, XPathElement xpath) {
		stream << "XPathElement \"" << xpath.name << "\": \"" <<
			xpath.xpath << "\" ";

		if (xpath.def_val)
			stream << "default: \"" << *xpath.def_val << '"';
		else
			stream << "no default";
		return stream;
	}

	std::ostream& operator<< (std::ostream& parStream, const duck::sl::SourceInfo& parInfo) {
		if (duck::sl::SourceInfo::URL == parInfo.type)
			parStream << '"' << parInfo.value << '"';
		else if (duck::sl::SourceInfo::Token == parInfo.type)
			parStream << '$' << parInfo.value;
		else
			parStream << "Invalid SourceInfo type";
		return parStream;
	}

	std::ostream& operator<< (std::ostream& stream, const FromBlock& blk) {
		stream << "FromBlock: " << blk.source << ", " <<
			blk.xpaths.size() << " xpath entries";
		return stream;
	}

	std::ostream& operator<< (std::ostream& stream, const StructBlock& strct) {
		stream << "StructBlock \"" << strct.name << "\" with " <<
			strct.xpaths.size() << " xpath entries";
		return stream;
	}

	std::ostream& operator<< (std::ostream& stream, const ApplyBlock& app) {
		stream << "ApplyBlock for \"" << app.mustache_model << "\": " <<
			app.source << ", " <<
			app.xpaths.size() << " elements";
		return stream;
	}
}} //namespace duck::sl

#endif
