/*  Copyright (C) 2015 Michele Santullo
 *
 *  This file is part of DuckScraper.
 *
 *  DuckScraper is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  DuckScraper is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with DuckScraper.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef id46DB8F4F85E2417E9AF0B1A410240D4F
#define id46DB8F4F85E2417E9AF0B1A410240D4F

#include "html_pool_base.hpp"
#include "xpath_fwd.hpp"
#include <map>
#include <string_view>
#include <string>

namespace duck { namespace sl {
	class XPathRunner {
	public:
		XPathRunner (HtmlPoolBaseSP html_pool, XPathPtr& parXPath, std::string&& parDefNamespace);
		~XPathRunner();

		const std::vector<std::string>& query (
			std::string_view parSrc,
			std::string_view parQuery
		);

	private:
		struct XPathKey;

		std::map<XPathKey, std::vector<std::string>> m_cached_results;
		std::string m_def_namespace;
		HtmlPoolBaseSP m_pool;
		XPathPtr m_xpath;
	};
}} //namespace duck::sl

#endif
